#!/usr/bin/env ruby

def helloWorld
  puts "Hello, World!"
end

helloWorld

puts "====>     "

def saySomething(text = 'Hello, World!')
    puts text
end

saySomething
saySomething()
saySomething "     "
saySomething("   ")

puts "====>   -  "

def printOneMoreThan(x)
   x += 1
   puts "  : #{x}"
end

x = 1
puts ": #{x}"
printOneMoreThan(x)
puts ": #{x}"

puts "====>      "

def options(a=99, b=a+1)
  [a, b]
end

p options        # [99, 100]
p options(1)     # [1, 2]
p options(2, 4)  # [2, 4]

puts "====>      "

def varargs(a, *b)
  [a, b]
end

p varargs(1)       #  [1, []]
p varargs(1, 2)    #  [1, [2]]
p varargs(1, 2, 3) #  [1, [2, 3]]

def mixed(a, b=99, *c)
  [a, b, c]
end

puts

p mixed(1)           # [1, 99, []]
p mixed(1, 2)        # [1, 2, []]
p mixed(1, 2, 3)     # [1, 2, [3]]
p mixed(1, 2, 3, 4)  # [1, 2, [3, 4]]

puts "====>    "
def countUp(x = 0)
  puts "   X  #{x}"
  x += 1
end
x = countUp()
x = countUp(x)
x = countUp(x)

=begin

def numbersWord
  puts " :"
  a=gets.chop!
  b=a.split
  puts "      #{b.size}."
end
numbersWord

=end

